#include <stdio.h>
#include "JTextReaderObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJTextReaderObj = JTextReaderObj().Register();


const char* JTextReaderObj::className() const { return "JTextReaderObj";}


JObject* JTextReaderObj::clone() const { return new JTextReaderObj(*this);}


// class constructor
JTextReaderObj::JTextReaderObj() {
  igm = 1 + 1 + 1;
  ogm = 1 + 1;
  enabled = 0;
  file_is_open = 0;
  fp = NULL;
  lastLine = NULL;
}


void JTextReaderObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("TextFile"), rect);
}


boolean JTextReaderObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JTextReaderObj::inputTag(int n) {
  char* tag[] = {
    "filename",
    "enabled",
  "tick" };
  return( tag[n] );
}


int JTextReaderObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JTextReaderObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JTextReaderObj::outputTag(int n) {
  char* tag[] = {
    "line",
    "file_is_open" };
  return( tag[n] );
}


JFRect JTextReaderObj::inputArea(int n) {
  if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
  } else {
    return topArea( n, 1, 2, 0.25 );
  }
}


JFRect JTextReaderObj::outputArea(int n) {
  if ( n < 1 ) {
    return rightArea(n, 0, 1, 0.1, 0.8);
  } else {
    return bottomArea(n, 1, 1, 0.1, 0.8);
  }
}


int JTextReaderObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JTextReaderObj::outputFace(int n) {
  if ( n < 1 ) {
    return RIGHT;
  } else {
    return BOTTOM;
  }
}


JFPoint JTextReaderObj::inputPoint(int n, JLinkObj& link) {
  if (n<1) return leftPoint(n, link, 0, 1, 0.1, 0.8);
  return topPoint(n, link, 1, 2);
}


JFPoint JTextReaderObj::outputPoint(int n, JLinkObj& link) {
  if ( n < 1 ) {
    return rightPoint(n, link, 0, 1, 0.1, 0.8);
  } else {
    return bottomPoint(n, link, 1, 1, 0.1, 0.8);
  }
}


void JTextReaderObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = outline;
  } else if ( n == 1 ) {
    INT(data) = file_is_open;
  }
}


bool JTextReaderObj::readLine( FILE* fp ) {
	if ( fgets( &line[0], 500, fp ) == NULL ) {
		return( false );
	} else {
		line[499] = 0;
		return( true );
	}
}

#include <malloc.h>
#include <string.h>

char* newstrcpy( char* line ) {
	char* result = (char*)malloc( strlen( line ) + 1 );
	strcpy( result, line );
	return( result );
}
void JTextReaderObj::processLine() {
	outline = JString( &line[0], 2 );
	broadcast( 0 );
}



void JTextReaderObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case FILENAME:
    link.access( JStringData( filename ));
    break;
  case ENABLED:
    link.access(JIntegerData(enabled));
	if ( enabled && filename.length() > 0 ) {
		fp = fopen( filename, "r" );
	} else {
		if ( fp != NULL ) {
			fclose( fp );
		}
		fp = NULL;
	}
	if ( fp == NULL ) {
		file_is_open = false;
	} else {
		file_is_open = true;
	}
	broadcast( 1 );
    break;
  case TICK:
	  link.access( JIntegerData( tick ));
	  if ( tick ) {
	  	if ( enabled && fp != NULL ) {
			if ( readLine( fp )) {
				processLine();
			} else {
				fclose( fp );
				fp = NULL;
				file_is_open = false;
				broadcast( 1 );
			}
		}
	  }
	  break;

  default:
    break;
  }
}


